#include "bsp_adc.h"

#include "bsp_uart.h"
#include "log.h"

#include "bsp_ml307r.h"
#include "bsp_led.h"

#undef LOG_ENABLE
#define LOG_ENABLE 1

#define LOG_LVL    LOG_DEBUG

#undef LOG_TAG
#define LOG_TAG "adc"

uint16_t adcBuff[40];

// ǰĹѹ mv
uint16_t vbat_mv;
// ǰĵĵѹ mv
uint16_t coil_mv;

signed short RoughCalib_Value  = 0; // ADCֵƫֵ

tmosTaskID adc_task_id = INVALID_TASK_ID;
static uint8_t vbat_low_flag   = 0; // ѹͱ־

void BSP_VBAT_IoInit(void)
{
    // Ĭ£ADC ź GPIO ŵֹͬʱڵ
    // ڽ ADC ʱҪ GPIO Ϊ
    //  ADC ĵƽм̬ʱʱᵼֲ©
    // ʱǿͨĴ R16_PIN_ANALOG_IE ص AIN ͨڵֹ:
    R32_PIN_IN_DIS |= ADC_VBAT_PIN; // ֹ
    GPIOA_ModeCfg(ADC_VBAT_PIN, GPIO_ModeIN_Floating);
}

void BSP_COIL_IoInit(void)
{
    R32_PIN_IN_DIS |= ADC_COIL_PIN; // ֹ
    GPIOA_ModeCfg(ADC_COIL_PIN, GPIO_ModeIN_Floating);
}

void BSP_VBAT_AdcInit(void)
{
    // 0dB(1) (ADC/2048)*Vref 2*Vref 0V2.1V 0V2V
    ADC_ExtSingleChSampInit(SampleFreq_4_or_2, ADC_PGA_0);

    ADC_ChannelCfg(ADC_VBAT_CHANNEL);
}

// TODO:ʹ֣ܲѡ0#ͨʵǶA0ˣA2ˣĵѹвת
void BSP_COIL_AdcInit(void)
{
    // 12dB(4) 0V (ADC/8192-0.25)*Vref 0.25*Vref 0V0.26V 0V0.23V
    ADC_ExtDiffChSampInit(SampleFreq_4_or_2, ADC_PGA_4);
    ADC_ChannelCfg(ADC_COIL_CHANNEL);

    // ADC_VoltConverDiffPGA_12dB(ADC_COIL_CHANNEL);
}

// https://www.cnblogs.com/iot-fan/p/14304854.html
uint16_t BSP_ReadVbat(void)
{
    uint8_t i                     = 0;
    uint32_t countadc             = 0;
    uint16_t min_number           = 0;
    uint16_t max_number           = 0;

    BSP_VBAT_AdcInit();
    ADC_ExcutSingleConver(); // ʱ㹻ʱٴת״ADC
    for (i = 0; i < ADC_SAMPLING_TIME; i++)
    {
        adcBuff[i] = ADC_ExcutSingleConver() + RoughCalib_Value; // 20
        // DelayMs(1);
    }
    for (i = 0; i < ADC_SAMPLING_TIME; i++)
    {
        countadc += ADC_VoltConverSignalPGA_0dB(adcBuff[i]);
        if (i == 0)
        {
            min_number = ADC_VoltConverSignalPGA_0dB(adcBuff[i]);
            max_number = ADC_VoltConverSignalPGA_0dB(adcBuff[i]);
        }
        min_number = ((min_number > ADC_VoltConverSignalPGA_0dB(adcBuff[i])) ? ADC_VoltConverSignalPGA_0dB(adcBuff[i]) : min_number); // ˲
        max_number = ((max_number < ADC_VoltConverSignalPGA_0dB(adcBuff[i])) ? ADC_VoltConverSignalPGA_0dB(adcBuff[i]) : max_number);
    }
    logDebug("min=%d, max=%d, diff=%d", min_number, max_number, (max_number - min_number));
    countadc = (countadc - min_number - max_number) / (ADC_SAMPLING_TIME - 2); // ɾСֵ
    logDebug("countaveradc = %d", countadc);
    vbat_mv = countadc * 3;
    logDebug("VBAT = %d mV", vbat_mv);

    return vbat_mv;
}

// https://www.cnblogs.com/iot-fan/p/14304854.html
uint16_t BSP_ReadCoil(void)
{
    uint8_t i                     = 0;
    uint32_t countadc             = 0;
    uint16_t min_number           = 0;
    uint16_t max_number           = 0;

    BSP_COIL_AdcInit();
    ADC_ExcutSingleConver(); // ʱ㹻ʱٴת״ADC
    for (i = 0; i < ADC_SAMPLING_TIME; i++)
    {
        adcBuff[i] = ADC_ExcutSingleConver() + RoughCalib_Value; // 20
        // DelayMs(1);
    }
    for (i = 0; i < ADC_SAMPLING_TIME; i++)
    {
        countadc += ADC_VoltConverSignalPGA_0dB(adcBuff[i]);
        if (i == 0)
        {
            min_number = ADC_VoltConverSignalPGA_0dB(adcBuff[i]);
            max_number = ADC_VoltConverSignalPGA_0dB(adcBuff[i]);
        }
        min_number = ((min_number > ADC_VoltConverSignalPGA_0dB(adcBuff[i])) ? ADC_VoltConverSignalPGA_0dB(adcBuff[i]) : min_number); // ˲
        max_number = ((max_number < ADC_VoltConverSignalPGA_0dB(adcBuff[i])) ? ADC_VoltConverSignalPGA_0dB(adcBuff[i]) : max_number);
    }
    logDebug("min=%d, max=%d, diff=%d", min_number, max_number, (max_number - min_number));
    countadc = (countadc - min_number - max_number) / (ADC_SAMPLING_TIME - 2); // ɾСֵ
    logDebug("countaveradc = %d", countadc);
    vbat_mv = countadc * 3;
    logDebug("VBAT = %d mV", vbat_mv);

    return vbat_mv;
}

uint16_t VBAT_ProcessEvent(uint8_t task_id, uint16_t events)
{
    if (events & VBAT_CHECK_EVT)
    {
        BSP_ReadVbat();
        return (events ^ VBAT_CHECK_EVT);
    }
    return 0;
}

void BSP_ADC_Init(void)
{
    BSP_VBAT_IoInit();
    // BSP_COIL_IoInit();

    BSP_VBAT_AdcInit();
    // 0dB(1) (ADC/2048)*Vref 2*Vref 0V2.1V 0V2V
    // ADC_ExtSingleChSampInit(SampleFreq_4_or_2, ADC_PGA_0);

    // ݴֵ,ȡƫֵ,ADCô˺ȡУ׼ֵ
    RoughCalib_Value = ADC_DataCalib_Rough(); // ڼADCڲƫ¼ȫֱ RoughCalib_Value
    logDebug("RoughCalib_Value =%d", RoughCalib_Value);

    adc_task_id = TMOS_ProcessEventRegister(VBAT_ProcessEvent);
    logDebug("adc_task_id = %d", adc_task_id);
    tmos_start_task(adc_task_id, VBAT_CHECK_EVT, MS1_TO_SYSTEM_TIME(1000));
}




